package com.huigou.topsun.product.controller;

import com.huigou.topsun.base.coderule.domain.model.CodeRuleKind;
import com.huigou.topsun.product.domain.Product;
import com.huigou.topsun.product.application.ProductApplication;
import com.huigou.topsun.resource.vo.ResourceFiledVo;
import org.springframework.data.domain.Page;
import com.huigou.uasp.annotation.ControllerMapping;
import com.huigou.uasp.client.CommonController;
import com.huigou.util.SDO;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

/**
 * ProductController
 *
 * @author qinzhenguan
 * @date 2023/11/27 11:19
 **/
@Controller
@ControllerMapping("/product")
public class ProductController extends CommonController {

    @Autowired
    private ProductApplication productService;

    @Override
    protected String getPagePath() {
        return "/biz/topsun/product/";
    }

    /**
     * description 
     * @author qinzhenguan
     * @date 2023/11/27 11:49
     * @return null
     */
    public String findProduct() {//需要特定类型返回值
        SDO sdo = this.getSDO();
//        int page = sdo.getInteger("page");
//        int size = sdo.getInteger("size");
        ArrayList<Map<String,Object>> productPage = productService.findProductPage(0, 30);
        HashMap<Object, Object> map = new HashMap<>();
        map.put("Rows",productPage);
        return toResult(map);
    }

    public String queryDetailAll() {
        SDO sdo = this.getSDO();
        String productId = sdo.getString("id");
        Map<String, Object> map = productService.queryDetailAll(Integer.parseInt(productId));

        return toResult(map);
    }

    public String forwardProduct() {
        this.putAttribute("ruleKindList", CodeRuleKind.getMap());
        return forward("product");
    }

    public String forwardProductDetail() {
        SDO sdo = this.getSDO();
        String productId = sdo.getString("productId");
        HashMap<String, Object> map = new HashMap<>();
        map.put("productId", productId);
        Map<String, Object> map2 = productService.queryDetailAll(Integer.parseInt(productId));

        return forward("productDetail", map);
    }



}